package com.dbxml.db.core.security;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: UserStack.java,v 1.3 2004/02/12 00:17:57 bradford Exp $
 */

import java.util.Stack;

/**
 * UserStack manages a Stack of authenticated Users.  It is
 * passed to secure classes that need to perform access
 * control overrides with alternate Users.  Its primary use
 * is to push the Magic User onto the stack for access to
 * low-level system resources.
 */

public final class UserStack {
   private static final ThreadLocal stack = new ThreadLocal() {
      protected synchronized Object initialValue() {
         return new Stack();
      }
   };

   public User getCurrentUser() {
      Stack s = (Stack)stack.get();
      if ( !s.isEmpty() )
         return (User)s.peek();
      else
         return null;
   }

   public void pushCurrentUser(User user) {
      Stack s = (Stack)stack.get();
      s.push(user);
   }

   public User popCurrentUser() {
      Stack s = (Stack)stack.get();
      if ( !s.isEmpty() )
         return (User)s.pop();
      else
         return null;
   }

   public void clear() {
      Stack s = (Stack)stack.get();
      if ( !s.isEmpty() )
         s.clear();
   }
}
